-- trident building inventory tracker
-- created by mr_spuck

local itemreqs = {
	["Fluid Formable Silksteel Alloy"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Synthetic Silksteel"] = 8,
			["Silksteel"] = 50,
			["Premium Carbonic Ore"] = 5,
			["Premium VanAzek Ore"] = 10,
			["Heliocene Ore"] = 3,
			["Lanthanic Ore"] = 6
		}
	},
	["Fused Composite Plating"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Synthetic Silksteel"] = 8,
			["Silksteel"] = 8,
			["Heliocene Ore"] = 3,
			["Synthetic Hydrocarbons"] = 15,
			["Outer Hull Plate"] = 15,
			["Plasteel"] = 5,
			["XiRite Alloy"] = 10,
			["Pentric Ore"] = 2
		}
	},
	["Merged Cybernetics Array"] = {
		station = {
			["Bractus M-14"] = true
		},
		reqs = {
			["Lanthanic Ore"] = 16,
			["Pentric Ore"] = 6,
			["Milanar Neural Nodule"] = 1,
			["Prosus Neural Nodule"] = 1,
			["Siepos Neural Nodule"] = 1,
			["Data Link Connectors"] = 20,
			["Superconductors"] = 12,
			["Thermal Insulator Tiles"] = 15,
			["Cybernetics Grade EE"] = 4,
			["Unassembled Cargo Crates"] = 1
		}
	},
	["Milanar Optical Sensor"] = {
		station = {
			["Bractus M-14"] = true
		},
		reqs = {
			["Apicene Ore"] = 17,
			["Denic Ore"] = 6,
			["Plasteel"] = 200,
			["Data Link Connectors"] = 16,
			["Thermal Insulator Tiles"] = 10,
			["Unassembled Cargo Crates"] = 1,
			["Milanar Observer Optics"] = 2,
			["Basic Targeting Systems"] = 4,
			["Optics"] = 20,
			["Thermal Imagers"] = 2,
			["Scanner Circuit Boards"] = 4
		}
	},
	["Milanar Master Computing System"] = {
		station = {
			["Bractus M-14"] = true
		},
		reqs = {
			["Ishik Ore"] = 9,
			["Lanthanic Ore"] = 250,
			["Data Link Connectors"] = 256,
			["Superconductors"] = 64,
			["Thermal Insulator Tiles"] = 24,
			["Unassembled Cargo Crates"] = 1,
			["Milanar Data Aggregator"] = 1,
			["Cybernetics Grade FF"] = 8,
			["Merged Cybernetics Array"] = 64
		}
	},
	["Reinforced Bulkhead"] = {
		station = {
			["Bractus M-14"] = true,
			["Nyrius F-6"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 5,
			["Fused Composite Plating"] = 2,
			["Silksteel"] = 6,
			["Premium Ishik Ore"] = 8,
			["Heliocene Ore"] = 2,
			["Lanthanic Ore"] = 4
		}
	},
	["Internal Bulkhead Assembly"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 1,
			["Reinforced Bulkhead"] = 3,
			["Premium Carbonic Ore"] = 90,
			["Premium Xithricite Ore"] = 40,
			["Heliocene Ore"] = 7,
			["Lanthanic Ore"] = 9,
			["Data Link Connectors"] = 20,
			["Fire-suppression system"] = 1
		}
	},
	["External Hull Assembly"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 5,
			["Fused Composite Plating"] = 5,
			["Internal Bulkhead Assembly"] = 2,
			["Premium Carbonic Ore"] = 70,
			["Premium VanAzek Ore"] = 19,
			["Heliocene Ore"] = 7,
			["Lanthanic Ore"] = 9,
			["Hull Panels"] = 250
		}
	},
	["Engine Pylon Assembly"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 5,
			["Fused Composite Plating"] = 10,
			["Internal Bulkhead Assembly"] = 1,
			["Premium Xithricite Ore"] = 260,
			["Heliocene Ore"] = 11,
			["Lanthanic Ore"] = 14,
			["Outer Hull Plate "] = 60,
			["Data Link Connectors"] = 10,
			["Engine Mounts"] = 32,
			["Radiation Containment Kit"] = 16
		}
	},
	["Docking Bay Hanger Assembly"] = {
		station = {
			["Bractus M-14"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 2,
			["Fused Composite Plating"] = 5,
			["Internal Bulkhead Assembly"] = 2,
			["Premium Ferric Ore"] = 131,
			["Heliocene Ore"] = 4,
			["Lanthanic Ore"] = 10,
			["Outer Hull Plate "] = 10,
			["Data Link Connectors"] = 2,
		}
	},
	["200MW Toroidal Hyper-Plasma Reactor"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 20,
			["Fused Composite Plating"] = 16,
			["Synthetic Silksteel"] = 16,
			["Premium Carbonic Ore"] = 180,
			["Premium Ferric Ore"] = 220,
			["Premium Ishik Ore"] = 19,
			["Premium Xithricite Ore"] = 40,
			["Heliocene Ore"] = 10,
			["Lanthanic Ore"] = 15,
			["Plasteel"] = 60,
			["Data Link Connectors"] = 64,
			["Radiation Containment Kit"] = 30,
			["Coolant"] = 500,
			["Energy Conversion Module"] = 128,
			["Power Regulators"] = 256,
			["Samoflange"] = 1
		}
	},
	["80MW Inverted Pulse Displacement Engine"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 25,
			["Fused Composite Plating"] = 8,
			["Synthetic Silksteel"] = 8,
			["Premium Carbonic Ore"] = 240,
			["Premium Ferric Ore"] = 180,
			["Premium Ishik Ore"] = 16,
			["Premium Xithricite Ore"] = 50,
			["Heliocene Ore"] = 8,
			["Lanthanic Ore"] = 22,
			["Synthetic Hydrocarbons"] = 22,
			["Data Link Connectors"] = 16,
			["Coolant"] = 250,
			["Energy Conversion Module"] = 4,
			["Power Regulators"] = 90,
			["Hydraulic Tappets"] = 16
		}
	},
	["Trident Type M"] = {
		station = {
			["Latos M-7"] = true
		},
		reqs = {
			["Fluid Formable Silksteel Alloy"] = 20,
			["Fused Composite Plating"] = 30,
			["Milanar Optical Sensor"] = 1,
			["Milanar Master Computing System"] = 1,
			["Internal Bulkhead Assembly"] = 8,
			["External Hull Assembly"] = 8,
			["Engine Pylon Assembly"] = 2,
			["Docking Bay Hanger Assembly"] = 4,
			["200MW Toroidal Hyper-Plasma Reactor"] = 1,
			["80MW Inverted Pulse Displacement Engine"] = 2,
			["Premium Silicate Ore"] = 1000,
			["Premium Carbonic Ore"] = 2000,
			["Premium Ferric Ore"] = 600,
			["Premium VanAzek Ore"] = 200,
			["Premium Ishik Ore"] = 200,
			["Premium Xithricite Ore"] = 400,
			["Heliocene Ore"] = 350,
			["Lanthanic Ore"] = 280,
			["Apicene Ore"] = 160,
			["Denic Ore"] = 300,
			["Outer Hull Plate "] = 100,
			["Data Link Connectors"] = 512,
			["Hull Panels"] = 200,
			["Fire-suppression system"] = 8,
			["Basic Targeting Systems"] = 6,
			["Power Regulators"] = 100,
			["Airlock Maintenance Supplies"] = 5,
			["Commercial Textiles"] = 10,
			["Bearing Grease"] = 14,
			["Doppler Array"] = 4,
			["Escape Hatch System"] = 2,
			["Exhaust Manifold"] = 8,
			["External Equipment Mounts"] = 24,
			["External Thermal Couplers"] = 16,
			["Extravehicular Suits"] = 2,
			["Flight Assist Control Module"] = 4,
			["Frequency Modulators"] = 6,
			["Gyroscopes"] = 2,
			["Cooling Systems"] = 20,
			["Oxygen Recycling System"] = 16,
			["Stabilizing Systems"] = 64,
			["Advanced Targeting Systems"] = 6,
			["Instrumentation Panel"] = 20,
			["Life Support System"] = 4,
			["Navigation Unit"] = 8,
			["Pilot Safety Harness"] = 8,
			["Ship Paint"] = 160
		}
	},
	["Siepos Master Computing System"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Ishik Ore"] = 9,
			["Pyronic Ore"] = 250,
			["Data Link Connectors"] = 256,
			["Superconductors"] = 64,
			["Thermal Insulator Tiles"] = 24,
			["Unassembled Cargo Crates"] = 1,
			["Siepos Data Aggregator"] = 1,
			["Cybernetics Grade FF"] = 8,
			["Merged Cybernetics Array"] = 64
		}
	},
	["Siepos Optical Sensor"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Apicene Ore"] = 17,
			["Denic Ore"] = 6,
			["Plasteel"] = 200,
			["Data Link Connectors"] = 16,
			["Thermal Insulator Tiles"] = 10,
			["Unassembled Cargo Crates"] = 1,
			["Siepos Observer Optics"] = 2,
			["Basic Targeting Systems"] = 4,
			["Optics"] = 20,
			["Thermal Imagers"] = 2,
			["Scanner Circuit Boards"] = 4
		}
	},
	["Prosus Master Computing System"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Ishik Ore"] = 9,
			["Apicene Ore"] = 250,
			["Data Link Connectors"] = 256,
			["Superconductors"] = 64,
			["Thermal Insulator Tiles"] = 24,
			["Unassembled Cargo Crates"] = 1,
			["Prosus Data Aggregator"] = 1,
			["Cybernetics Grade FF"] = 8,
			["Merged Cybernetics Array"] = 64
		}
	},
	["Prosus Optical Sensor"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Apicene Ore"] = 17,
			["Denic Ore"] = 6,
			["Plasteel"] = 200,
			["Data Link Connectors"] = 16,
			["Thermal Insulator Tiles"] = 10,
			["Unassembled Cargo Crates"] = 1,
			["Prosus Observer Optics"] = 2,
			["Basic Targeting Systems"] = 4,
			["Optics"] = 20,
			["Thermal Imagers"] = 2,
			["Scanner Circuit Boards"] = 4
		}
	},
	["Aeolus Light Repair Turret"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Power Regulators"] = 1,
			["Guided Missile Casings"] = 6,
			["Solid Fuel Packs"] = 6,
			["Advanced Targeting Systems"] = 1,
			["Plasteel"] = 2,
			["Heliocene Ore"] = 4,
			["Pentric Ore"] = 2,
			["Dentek Processor Core"] = 1
		}
	},
	["Biocom Miniature Tellar-Ulam Mine"] = {
		station = {
			["Latos I-8"] = true
		},
		reqs = {
			["Power Regulators"] = 16,
			["Premium Carbonic Ore"] = 280,
			["Premium VanAzek Ore"] = 50,
			["Premium Ferric Ore"] = 460,
			["Premium Silicate Ore"] = 80,
			["Pentric Ore"] = 40,
			["Premium Xithricite Ore"] = 60,
			["Solid Explosives"] = 22,
			["Plasteel"] = 4,
			["Amplification Module"] = 20,
			["Plasma Core"] = 16,
			["XiRite Alloy"] = 10,
			["Queen Processor Core"] = 4,
			["Dentek Processor Core"] = 4,
			["Outer Hull Plate "] = 6,
			["Hull Panels"] = 4,
			["Guardian Processor Core"] = 16,
			["Artemis Processor Core"] = 24
		}
	},
	["Centurion Superlight"] = {
		station = {
			["Sedina D-14"] = true
		},
		reqs = {
			["Instrumentation Panel"] = 2,
			["Premium Carbonic Ore"] = 70,
			["Premium VanAzek Ore"] = 50,
			["Premium Ferric Ore"] = 60,
			["Premium Silicate Ore"] = 19,
			["Pentric Ore"] = 10,
			["Premium Xithricite Ore"] = 45,
			["Thrust Regulators"] = 4,
			["Thermal Insulator Tiles"] = 15,
			["Engine Mounts"] = 8,
			["Data Link Connectors"] = 6,
			["Pilot Safety Harness"] = 1,
			["Navigation Unit"] = 2,
			["Propellant Actuators"] = 4,
			["Outer Hull Plate "] = 6,
			["Hull Panels"] = 15,
			["Guardian Processor Core"] = 4,
			["Artemis Processor Core"] = 8
		}
	},
	["Furrie"] = {
		station = {
			["Verasi E-14"] = true
		},
		reqs = {
			["Apicene Ore"] = 10,
			["Lanthanic Ore"] = 20,
			["Premium Aquean Ore"] = 40,
			["Premium Xithricite Ore"] = 30,
			["LCD"] = 6,
			["Gyroscopes"] = 6,
			["Advanced Logistics System"] = 1,
			["Guardian Processor Core"] = 3
		}
	},
	["FireCracker Homing Missile - Turret"] = {
		station = {
			["Bractus M-14"] = true
		},
		reqs = {
			["Power Regulators"] = 1,
			["Guided Missile Casings"] = 6,
			["Solid Fuel Packs"] = 6,
			["Advanced Targeting Systems"] = 1,
			["Plasteel"] = 2,
			["Heliocene Ore"] = 4,
			["Pentric Ore"] = 2,
			["Solid Explosives"] = 3,
			["Dentek Processor Core"] = 2
		}
	},
	["Neutron MkIII Turret"] = {
		station = {
			["Pelatus C-12"] = true
		},
		reqs = {
			["Power Regulators"] = 1,
			["Premium Carbonic Ore"] = 15,
			["Premium VanAzek Ore"] = 10,
			["Advanced Targeting Systems"] = 1,
			["Heliocene Ore"] = 5,
			["Lanthanic Ore"] = 2,
			["Silksteel"] = 5,
			["Ion Core"] = 1,
			["Dentek Processor Core"] = 1
		}
	}
}

local itemtypes = {}
for item,iteminfo in pairs(itemreqs) do
	itemtypes[item] = true
	for req in pairs(iteminfo.reqs) do
		itemtypes[req] = true
	end
end

local SETTINGSYS = 387587842

local defaultsettings = {
	nearbystations = {
	},
	locationfilter = 3,
	locationfilter_custom = {
	},
	showitem = "Trident Type M",
	showitem_count = 1
}

local settings

local function load_settings()
	if GetPlayerName() then
		local notedata = unspickle(LoadSystemNotes(SETTINGSYS))
		for i in pairs(defaultsettings) do
			if not notedata[i] then
				settings = defaultsettings
				return
			end
		end
		settings = notedata
	end
end

local function save_settings()
	if GetPlayerName() then
		SaveSystemNotes(spickle(settings), SETTINGSYS)
	end
end

local function manuprint(str)
	print(str)
end

local function tablekeys(t)
	local ret = {}
	for i,v in pairs(t) do
		table.insert(ret, i)
	end
	return ret
end

local itemclasses = {
	[CLASSTYPE_GENERIC] = true,
	[CLASSTYPE_SHIP] = true,
	[CLASSTYPE_ADDON] = true
}

local function get_player_inventory()
	local items = {}
	for _,item in PlayerInventoryPairs() do
		if itemclasses[GetInventoryItemClassType(item)] and itemtypes[GetInventoryItemName(item)] then
			table.insert(items, {type=GetInventoryItemName(item),
					     station=ShortLocationStr(SplitStationID(GetInventoryItemLocation(item))),
					     count=GetInventoryItemQuantity(item)})
		end
	end
	return items
end


local function create_tree(name, count)
	local node = { name = name, count = count }
	for reqname,reqcount in pairs(itemreqs[name] and itemreqs[name].reqs or {}) do
		node.children = node.children or {}
		table.insert(node.children, create_tree(reqname, reqcount * count))
	end
	return node
end


local function count_items(tree, item)
	local count = (tree.name == item) and tree.count or 0 
	for i,childnode in ipairs(tree.children or {}) do
		count = count + count_items(childnode, item)
	end
	return count
end


local function get_manu_stations()
	local stations = {}
	for _,iteminfo in pairs(itemreqs) do
		for station in pairs(iteminfo.station) do
			stations[station] = true
		end
	end
	return stations
end


-- really awkward way to get the location of all stations
-- TODO: find a better way or hardcode it
local function get_universe_stations()
	local stations = get_manu_stations()
	for i=1,30 do
		local sysinfo = dofile(string.format("lua/maps/system%02dmap.lua", i))
		for j,sectorinfo in ipairs(sysinfo[1]) do
			if sectorinfo.icon == "images/nav_station_wormhole.png" or sectorinfo.icon == "images/nav_station.png" then
				stations[ShortLocationStr(256 * (i - 1) + sectorinfo.id)] = true
			end
		end
	end

	return stations
end


local function manu(target, count)

	local obj = {}

	local manunearbystations = {}
	
	local tree

	local manutarget
	local manuitemreqs

	local inventory = {}
	local reducedinventory = {}

	function obj:set_target(target, count)
		tree = create_tree(target, count or 1)
		manuitemreqs = {}
		for item,iteminfo in pairs(itemreqs) do
			if count_items(tree, item) > 0 then
				manuitemreqs[item] = iteminfo
			end
		end
		manutarget = target

		-- set_inventory rebuilds the reduced inventory
		self:set_inventory(inventory)
	end

	function obj:get_item_count(type)
		type = type or manutarget

		local ret = 0
		for _,iteminfo in pairs(inventory) do
			if iteminfo.type == type then
				ret = ret + iteminfo.count
			end
		end
		return ret
	end

	function obj:get_station_item_count(station, type)
		local ret = 0
		for _,iteminfo in pairs(reducedinventory) do
			if iteminfo.station == station and iteminfo.type == type then
				ret = ret + iteminfo.count
			end
		end
		return ret
	end

	function obj:get_station_nearby_item_count(station, type)
		local ret = 0
		if manunearbystations[station] then
			for _,iteminfo in pairs(reducedinventory) do
				if manunearbystations[station][iteminfo.station] and iteminfo.type == type then
					ret = ret + iteminfo.count
				end
			end
		end
		return ret
	end

	function obj:num_needed(item)
		-- how many of each item is needed for the trident
		local neededcount = count_items(tree, item)

		-- substract finished items and ones that have been consumed by other parts
		for _,finisheditem in pairs(reducedinventory) do
			neededcount = neededcount - count_items(create_tree(finisheditem.type, finisheditem.count), item)
		end
		
		return neededcount
	end

	function obj:get_itemreqs(item)
		local ret = {}
		if manuitemreqs[item] then
			for i,v in pairs(manuitemreqs[item].reqs) do
				ret[i] = v
			end
		end
		return ret
	end

	-- TODO: the results of these 3 should be cached until the next :set_inventory call
	function obj:needed_at_station(station)
		local makes = {}
		for item,iteminfo in pairs(manuitemreqs) do
			if iteminfo.station[station] then
				makes[item] = true
			end
		end

		local needed = {}
		for item in pairs(makes) do
			local neededcount = self:num_needed(item)

			for req,count in pairs(manuitemreqs[item].reqs) do
				needed[req] = (needed[req] or 0) + (neededcount * count)
			end
		end

		-- substract the items that we already have in the station
		-- XXX check if this can be done in-place with lua
		local ret = {}
		for item,count in pairs(needed) do
			local atstation = self:get_station_item_count(station, item)
			local nearby = self:get_station_nearby_item_count(station, item)
			ret[item] = { math.max(count - atstation, 0), math.max(count - (atstation + nearby), 0) }
		end

		return ret
	end

	function obj:stored_at_station(station)
		local stored = {}
		for item,iteminfo in pairs(manuitemreqs) do
			if iteminfo.station[station] then
				stored[item] = stored[item] or { self:get_station_item_count(station, item), self:get_station_nearby_item_count(station, item) }
				for reqitem in pairs(iteminfo.reqs) do
					stored[reqitem] = stored[reqitem] or { self:get_station_item_count(station, reqitem), self:get_station_nearby_item_count(station, reqitem) }
				end
			end
		end
		return stored
	end


	-- what and how much can currently be build at this station
	function obj:buildable_at_station(station)
		local stored = self:stored_at_station(station)

		local makes = {}
		for item,iteminfo in pairs(manuitemreqs) do
			if iteminfo.station[station] then
				makes[item] = true
			end
		end

		local ret = {}

		for item in pairs(makes) do
			local buildcount
			for req,reqcount in pairs(manuitemreqs[item].reqs) do
				if not stored[req] then
					buildcount = 0
				end
				local tmpcount = math.floor((stored[req][1] + stored[req][2]) / reqcount)
				buildcount = math.min(buildcount or tmpcount, tmpcount)

				if buildcount == 0 then
					break
				end
			end
			ret[item] = buildcount
		end
		return ret
	end


	function obj:set_inventory(inv)
		inventory = inv
		reducedinventory = {}
		if target and tree then
			for _,iteminfo in pairs(inventory) do
				if count_items(tree, iteminfo.type) > 0 then
					table.insert(reducedinventory, iteminfo)
				end
			end
		end
	end

	function obj:set_nearby_stations(stations)
		manunearbystations = stations
	end

	obj:set_target(target, count)

	return obj
end


local function make_nearby_tab()
	local tabnearbystations = {}

	local stationlist = iup.pdasubsubsublist{DROPDOWN="YES", EXPAND="HORIZONTAL"}

	local stations = tablekeys(get_manu_stations())
	table.sort(stations)

	for i,station in ipairs(stations) do
		stationlist[i] = station
	end


	local univlist = iup.pdasubsubsublist{EXPAND="YES", MULTIPLE="YES"}

	local univstations = tablekeys(get_universe_stations())
	table.sort(univstations)

	for i,station in ipairs(univstations) do
		univlist[i] = station
	end


	function stationlist:action(sel)
		local value = ""
		if tabnearbystations[sel] then
			for _,station in ipairs(univstations) do
				value = value..(tabnearbystations[sel][station] and "+" or "-")
			end
		end
		univlist.value = value
	end

	function univlist:action()
		local station = stationlist[stationlist.value]

		local newstations = {}
		for i=1,#(univlist.value) do
			if string.sub(univlist.value, i, i) == "+" then
				newstations[univlist[i]] = true
			end
		end
		tabnearbystations[station] = newstations
	end

	local header = iup.label{title="Specify which stations are considered nearby to manufactoring stations.\nItems in these stations will be added to the manufactoring stations inventory.\n Careful: Assigning a station to multiple manufactoring stations may lead misleading numbers"}

	local tab = iup.vbox{header, iup.fill{size="5"}, stationlist, univlist}

	function tab:set_nearby_stations(stations)
		tabnearbystations = stations
		-- shitty hack.. force an update of the univlist
		stationlist:action(stationlist[stationlist.value])
	end

	function tab:get_nearby_stations()
		return tabnearbystations
	end

	function tab:OnShow()
	end

	function tab:OnHide()
	end

	return tab
end

local function make_inventory_tab()
	local invtree
	local infobox
	local itemcount

	local manuobj = manu("Trident Type M")

	local matrixstations = {}

	local function update()
		manuobj:set_inventory(get_player_inventory())

		itemcount.title = manuobj:get_item_count()
		iup.Refresh(itemcount)

		invtree.DELLIN = "1--1"

		local manustations = tablekeys(get_manu_stations())
		table.sort(manustations)

		matrixstations = {}

		local line = 1
		for _,station in ipairs(manustations) do

			local stored = manuobj:stored_at_station(station)
			local needed = manuobj:needed_at_station(station)

			-- add placeholders for items that are stored but not needed at the station
			-- usually ones that have been manufactored there
			-- TODO: maybe these should go at the end
			for item in pairs(stored) do
				needed[item] = needed[item] or {0, 0}
			end

			local neededarr = tablekeys(needed)
			table.sort(neededarr)

			if #neededarr > 0 then
				invtree.ADDLIN = line
				invtree:setcell(line, 1, station)
				matrixstations[line] = { station=station }
				line = line + 1
				
				for _,item in ipairs(neededarr) do
					-- NOTE: a bit needlessly complicated right now
					-- might allow displaying station and nearby numbers seperately at some point
					local colorstr = (needed[item][2] == 0) and "\127a0a0a0" or ""
					invtree.ADDLIN = line
					invtree:setcell(line, 1, colorstr..tostring(item))
					invtree:setcell(line, 2, colorstr..tostring(stored[item][1] + stored[item][2]))
					invtree:setcell(line, 3, colorstr..tostring(needed[item][2]))
					
					-- XXX store station associated with this line in a table
					-- could this be attached to a cell?
					matrixstations[line] = { station=station, item=item }
					
					line = line + 1
				end
				-- blank line between stations
				invtree.ADDLIN = line
				invtree:setcell(line, 1, "")
				line = line + 1
			end
		end

		infobox.VALUE = "Nothing selected"
	end

	itemcount = iup.label{title=""}
	local itemlist = iup.pdasubsubsublist{DROPDOWN="YES"}

	local itemnames = tablekeys(itemreqs)
	table.sort(itemnames)
	for i,item in ipairs(itemnames) do
		itemlist[i] = item
	end

	function itemlist:action(sel)
		manuobj:set_target(sel, settings.showitem_count)
		settings.showitem = sel
		update()
	end

	local itemtargetcount = iup.text{size="%20x", expand="NO"}
	function itemtargetcount:action(_, val)
		val = tonumber(val or 0) or 0
		if val >= 0 then
			manuobj:set_target(settings.showitem, val)
			settings.showitem_count = val
			update()
			return
		end
		return iup.IGNORE
	end

	invtree = iup.pdasubmatrix{NUMCOL=3, CELLSIZE=10, EXPAND="YES", size="1", BGCOLOR="0 0 0 0"}
	invtree["0:1"] = ""
	invtree["ALIGNMENT1"] = "ALEFT"
	invtree["0:2"] = "Stored"
	invtree["0:3"] = "Remaining"

	infobox = iup.stationsubmultiline{READONLY="YES", EXPAND="VERTICAL", SIZE="%25", VALUE="Nothing selected"}

	function invtree:edition_cb()
		return iup.IGNORE
	end

	function invtree:click_cb(line, col)
		local lineinfo = matrixstations[line]
		if not lineinfo then
			infobox.VALUE = ""
			return
		end

		local station = lineinfo.station

		local value = {}
		if lineinfo.item then
			local stored = manuobj:stored_at_station(station)

			table.insert(value, "Inventory: "..manuobj:get_item_count(lineinfo.item))
			
			local itemstored = stored[lineinfo.item] or {0, 0}
			table.insert(value, "Stored at station: "..itemstored[1])
			table.insert(value, "Stored nearby: "..itemstored[2])
			table.insert(value, "")

			for item,count in pairs(manuobj:buildable_at_station(station)) do
				if item == lineinfo.item then
					
					table.insert(value, "Needed overall: "..manuobj:num_needed(item))
					table.insert(value, "Ready to build: "..count)
					table.insert(value, "")
					table.insert(value, "To build more get at least:")

					for reqitem,reqcount in pairs(manuobj:get_itemreqs(item)) do
						-- XXX: too messy
						local reqitemstored = 0
						if stored[reqitem] then
							reqitemstored = stored[reqitem][1] + stored[reqitem][2] 
						end
						-- substract amount of requirement items that we have from what would be needed
						-- to build one more of this type
						local reqitemneeded = (reqcount * (count + 1)) - reqitemstored
						
						if reqitemneeded > 0 then
							table.insert(value, reqitemneeded.."x "..reqitem)
						end
					end
				end
			end

		else
			for item,count in pairs(manuobj:buildable_at_station(station)) do
				if count ~= 0 then
					table.insert(value, count.."x "..item.." ("..manuobj:num_needed(item).." needed)")
				end
			end
		
		
			if #value == 0 then
				table.insert(value, 1, "You can't currently build anything at "..tostring(station))
			else
				table.insert(value, 1, "At "..tostring(station).." you can currently build")
			end
		end
		infobox.VALUE = table.concat(value, "\n")
		infobox.CARET = "1,1"
	end


	local tab = iup.vbox{iup.hbox{iup.label{title="Build: "}, itemlist, iup.label{title=" Inventory: "}, itemcount, iup.fill{expand="HORIZONTAL"}, iup.label{title=" Target: "}, itemtargetcount},
			     iup.hbox{invtree, infobox}}

	function tab:OnShow()
		manuobj:set_nearby_stations(settings.nearbystations)

		itemtargetcount.value = settings.showitem_count

		local i = 1
		while itemlist[i] do
			if itemlist[i] == settings.showitem then
				itemlist.value = i
				break
			end
			i = i + 1
		end
		
		manuobj:set_target(settings.showitem, settings.showitem_count)
		update()
	end

	function tab:OnHide()
	end

	return tab
end


local function make_manu_dialog()
	local invtab = make_inventory_tab()
	invtab.tabtitle = "Inventory"
	local nearbytab = make_nearby_tab()
	nearbytab.tabtitle = "Station relations"

	function nearbytab:OnHide()
		settings.nearbystations = self:get_nearby_stations()
	end

	function nearbytab:OnShow()
		self:set_nearby_stations(settings.nearbystations)
	end

	local tabs = iup.subsubsubtabtemplate{invtab, nearbytab}
	local d = iup.dialog{iup.stationsubsubframe{iup.vbox{tabs}},
			     FULLSCREEN="NO", BGCOLOR="0 0 0 0 0", TOPMOST="YES", SIZE="%90xHALF"}

	function d:show_cb()
		load_settings()
		tabs:OnShow()
	end

	function d:hide_cb()
		tabs:OnHide()
		save_settings()
	end

	return d
end
local manudialog


local function manu_cb()
	if not GetPlayerName() then
		local msgdialog
		msgdialog = msgdlgtemplate1("You must be connected to the game to run this.", "Ok", function() HideDialog(msgdialog) iup.Destroy(msgdialog) end, "TWOTHIRDx%5")
		ShowDialog(msgdialog)
		return
	end

	-- dialog must be initialized from the command handler or the paths for
	-- get_universe_stations will be wrong
	if not manudialog then
		manudialog = make_manu_dialog()
	end

	ShowDialog(manudialog)
end

RegisterUserCommand("manu", manu_cb)